package rocks.zipcode.atm;

import javafx.fxml.FXMLLoader;
import javafx.scene.Group;
import javafx.scene.image.ImageView;

import rocks.zipcode.atm.bank.Bank;
import javafx.application.Application;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.TextArea;
import javafx.scene.control.TextField;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;
import javafx.scene.layout.FlowPane;



/**
 * @author ZipCodeWilmington
 */
public class CashMachineApp extends Application {



    private TextField field = new TextField();
    private CashMachine cashMachine = new CashMachine(new Bank());

    private Parent createContent() {
        VBox vbox = new VBox(10);
        vbox.setPrefSize(800, 800);

        TextArea areaInfo = new TextArea();
        areaInfo.setStyle("-fx-background-color: aquamarine;");

       /* Button btnCreateBasicAccount = new Button("Create Account");
        btnCreateBasicAccount.setOnAction(e -> {
            int id = Integer.parseInt(field.getText());
            cashMachine.login(id);

            areaInfo.setText(cashMachine.toString());
        });*/

        Button btnSubmit = new Button("Set Account ID");
        btnSubmit.setOnAction(e -> {
            int id = Integer.parseInt(field.getText());
            cashMachine.login(id);

            areaInfo.setText(cashMachine.getUser());
        });

        Button btnCheckBalance = new Button("Check Balance");
        btnCheckBalance.setOnAction(e -> {
            int amount = Integer.parseInt(field.getText());
            cashMachine.checkBalance();

            areaInfo.setText(cashMachine.getBalance());
        });

        Button btnAccountDetails = new Button("Account Information");
        btnAccountDetails.setOnAction(e -> {
            int amount = Integer.parseInt(field.getText());
            cashMachine.toString();

            areaInfo.setText(cashMachine.toString());
        });

        Button btnDeposit = new Button("Deposit");
        btnDeposit.setOnAction(e -> {
            int amount = Integer.parseInt(field.getText());
            cashMachine.deposit(amount);

            areaInfo.setText(cashMachine.getBalance());
        });

        Button btnWithdraw = new Button("Withdraw");
        btnWithdraw.setOnAction(e -> {
            int amount = Integer.parseInt(field.getText());
            cashMachine.withdraw(amount);

            areaInfo.setText(cashMachine.getBalance());
        });

        Button btnExit = new Button("Exit");
        btnExit.setOnAction(e -> {
            cashMachine.exit();

            areaInfo.setText(cashMachine.goodBye());
        });

        FlowPane flowpane = new FlowPane();

        flowpane.getChildren().add(btnSubmit);
        flowpane.getChildren().add(btnCheckBalance);
        flowpane.getChildren().add(btnDeposit);
        flowpane.getChildren().add(btnWithdraw);
        flowpane.getChildren().add(btnAccountDetails);
        flowpane.getChildren().add(btnExit);


        //Image image = new Image("file:atm.jpg");
        ImageView mv = new ImageView("file:atm.jpg");

        Group root = new Group();
        root.getChildren().addAll(mv);

        vbox.setStyle("-fx-background-color: silver; -fx-padding: 20; -fx-font-size: 20;");
        vbox.getChildren().addAll(field, flowpane, areaInfo);
        return vbox;
    }

    @Override
    public void start(Stage stage) throws Exception {

        stage.setTitle("ZIPCLOUD BANK");
        stage.setScene(new Scene(createContent()));
        stage.show();

        /*try {

            Parent root = FXMLLoader.load(getClass().getResource("/Users/thulasipuppala/Labs/CashMachine/src/main/java/rocks/zipcode/atm/Login.fxml"));
            Scene scene1 = new Scene(root, 600, 600);
            stage.setScene(scene1);
            stage.show();
        }
        catch (Exception e){
            e.printStackTrace();
        }*/
    }

    public static void main(String[] args) {
        launch(args);
    }
}
